#!/usr/bin/env python3
#
# Auto OVPN gnome extension
# https://jasonmun.blogspot.my
# https://github.com/yomun/auto-ovpn
# 
# Copyright (C) 2017 Jason Mun
# 
# Auto OVPN gnome extension is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Auto OVPN gnome extension is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Auto OVPN gnome extension.  If not, see <http://www.gnu.org/licenses/>.
#

import sys
import GeoIP

# python3 geoip-get-info.py 210.186.247.137
og = GeoIP.open("/usr/share/GeoIP/GeoIPASNum.dat", GeoIP.GEOIP_STANDARD)
gi = GeoIP.open("/usr/share/GeoIP/GeoIPCity.dat", GeoIP.GEOIP_STANDARD)

IP = sys.argv[1]

gir = gi.record_by_name(IP)

org = ""
	
if org is not None:
    org = og.org_by_addr(IP)

lat = ""
lng = ""

city = ""
region_name = ""
country_code = ""
country_name = ""
postal_code = ""

if gir is not None:
    city = gir['city']
    region_name = gir['region_name']
    country_code = gir['country_code']
    country_name = gir['country_name']
    lat = str(float("{0:.4f}".format(gir['latitude'])))
    lng = str(float("{0:.4f}".format(gir['longitude'])))
    postal_code = gir['postal_code']
    
print('{')
print('  "ip": "' + IP + '",')
print('  "hostname": "",')
print('  "city": "' + city + '",')
print('  "region": "' + region_name + '",')
print('  "country": "' + country_code + ' / ' + country_name + '",')
print('  "loc": "' + lat + ',' + lng + '",')
print('  "org": "' + org + '",')
print('  "postal": "' + postal_code + '"')
print('}')
